# selenium.webdriver.chrome.webdriver

Classes

`WebDriver`([options, service, keep_alive]) | Controls the ChromeDriver and allows you to drive the browser.

class selenium.webdriver.chrome.webdriver.WebDriver(options: Options = None, service: Service = None, keep_alive: bool = True)

  Controls the ChromeDriver and allows you to drive the browser.

  Creates a new instance of the chrome driver. Starts the service and then creates new instance of chrome driver.

  Args:

    - options - this takes an instance of ChromeOptions

    - service - Service object for handling the browser driver if you need to pass extra details

    - keep_alive - Whether to configure ChromeRemoteConnection to use HTTP keep-alive.

  add_cookie(cookie_dict) → None

    Adds a cookie to your current session.

    Args:
      - cookie_dict: A dictionary object, with required keys - “name” and “value”;

          optional keys - “path”, “domain”, “secure”, “httpOnly”, “expiry”, “sameSite”

    Usage:

          driver.add_cookie({'name' : 'foo', 'value' : 'bar'})
          driver.add_cookie({'name' : 'foo', 'value' : 'bar', 'path' : '/'})
          driver.add_cookie({'name' : 'foo', 'value' : 'bar', 'path' : '/', 'secure' : True})
          driver.add_cookie({'name' : 'foo', 'value' : 'bar', 'sameSite' : 'Strict'})

  add_credential(credential: Credential) → None

    Injects a credential into the authenticator.

  add_virtual_authenticator(options: VirtualAuthenticatorOptions) → None

    Adds a virtual authenticator with the given options.

  back() → None

    Goes one step backward in the browser history.

    Usage:

          driver.back()

  bidi_connection()
  property capabilities: dict

    Returns the drivers current capabilities being used.

  close() → None

    Closes the current window.

    Usage:

          driver.close()

  create_web_element(element_id: str) → WebElement

    Creates a web element with the specified element_id.

  property current_url: str

    Gets the URL of the current page.

    Usage:

          driver.current_url

  property current_window_handle: str

    Returns the handle of the current window.

    Usage:

          driver.current_window_handle

  delete_all_cookies() → None

    Delete all cookies in the scope of the session.

    Usage:

          driver.delete_all_cookies()

  delete_cookie(name) → None

    Deletes a single cookie with the given name.

    Usage:

          driver.delete_cookie('my_cookie')

  delete_downloadable_files() → None

    Deletes all downloadable files.

  delete_network_conditions() → None

    Resets Chromium network emulation settings.

  download_file(file_name: str, target_directory: str) → None

    Downloads a file with the specified file name to the target directory.

    file_name: The name of the file to download. target_directory: The path to the directory to save the downloaded file.

  execute(driver_command: str, params: dict = None) → dict

    Sends a command to be executed by a command.CommandExecutor.

    Args:

      - driver_command: The name of the command to execute as a string.

      - params: A dictionary of named parameters to send with the command.

    Returns:

      The command’s JSON response loaded into a dictionary object.

  execute_async_script(script: str, *args)

    Asynchronously Executes JavaScript in the current window/frame.

    Args:

      - script: The JavaScript to execute.

      - *args: Any applicable arguments for your JavaScript.

    Usage:

          script = "var callback = arguments[arguments.length - 1]; " \
                   "window.setTimeout(function(){ callback('timeout') }, 3000);"
          driver.execute_async_script(script)

  execute_cdp_cmd(cmd: str, cmd_args: dict)

    Execute Chrome Devtools Protocol command and get returned result The command and command args should follow chrome devtools protocol domains/commands, refer to link https://chromedevtools.github.io/devtools-protocol/

    Args:

      - cmd: A str, command name

      - cmd_args: A dict, command args. empty dict {} if there is no command args

    Usage:

          driver.execute_cdp_cmd('Network.getResponseBody', {'requestId': requestId})

    Returns:

      A dict, empty dict {} if there is no result to return. For example to getResponseBody: {‘base64Encoded’: False, ‘body’: ‘response body string’}

  execute_script(script, *args)

    Synchronously Executes JavaScript in the current window/frame.

    Args:

      - script: The JavaScript to execute.

      - *args: Any applicable arguments for your JavaScript.

    Usage:

          driver.execute_script('return document.title;')

  property file_detector: FileDetector
  file_detector_context(file_detector_class, *args, **kwargs)

    Overrides the current file detector (if necessary) in limited context. Ensures the original file detector is set afterwards.

    Example:

        with webdriver.file_detector_context(UselessFileDetector):
            someinput.send_keys('/etc/hosts')

    Args:
      - file_detector_class - Class of the desired file detector. If the class is different

          from the current file_detector, then the class is instantiated with args and kwargs and used as a file detector during the duration of the context manager.

      - args - Optional arguments that get passed to the file detector class during

          instantiation.

      - kwargs - Keyword arguments, passed the same way as args.

  find_element(by='id', value: str | None = None) → WebElement

    Find an element given a By strategy and locator.

    Usage:

          element = driver.find_element(By.ID, 'foo')

    Return type:

      WebElement

  find_elements(by='id', value: str | None = None) → List[WebElement]

    Find elements given a By strategy and locator.

    Usage:

          elements = driver.find_elements(By.CLASS_NAME, 'foo')

    Return type:

      list of WebElement

  forward() → None

    Goes one step forward in the browser history.

    Usage:

          driver.forward()

  fullscreen_window() → None

    Invokes the window manager-specific ‘full screen’ operation.

  get(url: str) → None

    Loads a web page in the current browser session.

  get_cookie(name) → Dict | None

    Get a single cookie by name. Returns the cookie if found, None if not.

    Usage:

          driver.get_cookie('my_cookie')

  get_cookies() → List[dict]

    Returns a set of dictionaries, corresponding to cookies visible in the current session.

    Usage:

          driver.get_cookies()

  get_credentials() → List[Credential]

    Returns the list of credentials owned by the authenticator.

  get_downloadable_files() → dict

    Retrieves the downloadable files as a map of file names and their corresponding URLs.

  get_issue_message()
    Returns:

      An error message when there is any issue in a Cast

    session.

  get_log(log_type)

    Gets the log for a given log type.

    Args:

      - log_type: type of log that which will be returned

    Usage:

          driver.get_log('browser')
          driver.get_log('driver')
          driver.get_log('client')
          driver.get_log('server')

  get_network_conditions()

    Gets Chromium network emulation settings.

    Returns:

      A dict. For example: {‘latency’: 4,

    ‘download_throughput’: 2, ‘upload_throughput’: 2, ‘offline’: False}

  get_pinned_scripts() → List[str]
  get_screenshot_as_base64() → str

    Gets the screenshot of the current window as a base64 encoded string which is useful in embedded images in HTML.

    Usage:

          driver.get_screenshot_as_base64()

  get_screenshot_as_file(filename) → bool

    Saves a screenshot of the current window to a PNG image file. Returns False if there is any IOError, else returns True. Use full paths in your filename.

    Args:

      - filename: The full path you wish to save your screenshot to. This should end with a .png extension.

    Usage:

          driver.get_screenshot_as_file('/Screenshots/foo.png')

  get_screenshot_as_png() → bytes

    Gets the screenshot of the current window as a binary data.

    Usage:

          driver.get_screenshot_as_png()

  get_sinks() → list
    Returns:

      A list of sinks available for Cast.

  get_window_position(windowHandle='current') → dict

    Gets the x,y position of the current window.

    Usage:

          driver.get_window_position()

  get_window_rect() → dict

    Gets the x, y coordinates of the window as well as height and width of the current window.

    Usage:

          driver.get_window_rect()

  get_window_size(windowHandle: str = 'current') → dict

    Gets the width and height of the current window.

    Usage:

          driver.get_window_size()

  implicitly_wait(time_to_wait: float) → None

    Sets a sticky timeout to implicitly wait for an element to be found, or a command to complete. This method only needs to be called one time per session. To set the timeout for calls to execute_async_script, see set_script_timeout.

    Args:

      - time_to_wait: Amount of time to wait (in seconds)

    Usage:

          driver.implicitly_wait(30)

  launch_app(id)

    Launches Chromium app specified by id.

  property log_types

    Gets a list of the available log types. This only works with w3c compliant browsers.

    Usage:

          driver.log_types

  maximize_window() → None

    Maximizes the current window that webdriver is using.

  minimize_window() → None

    Invokes the window manager-specific ‘minimize’ operation.

  property mobile: Mobile
  property name: str

    Returns the name of the underlying browser for this instance.

    Usage:

          name = driver.name

  property orientation

    Gets the current orientation of the device.

    Usage:

          orientation = driver.orientation

  property page_source: str

    Gets the source of the current page.

    Usage:

          driver.page_source

  pin_script(script: str, script_key=None) → ScriptKey

    Store common javascript scripts to be executed later by a unique hashable ID.

  print_page(print_options: PrintOptions | None = None) → str

    Takes PDF of the current page.

    The driver makes a best effort to return a PDF based on the provided parameters.

  quit() → None

    Closes the browser and shuts down the ChromiumDriver executable.

  refresh() → None

    Refreshes the current page.

    Usage:

          driver.refresh()

  remove_all_credentials() → None

    Removes all credentials from the authenticator.

  remove_credential(credential_id: str | bytearray) → None

    Removes a credential from the authenticator.

  remove_virtual_authenticator() → None

    Removes a previously added virtual authenticator.

    The authenticator is no longer valid after removal, so no methods may be called.

  save_screenshot(filename) → bool

    Saves a screenshot of the current window to a PNG image file. Returns False if there is any IOError, else returns True. Use full paths in your filename.

    Args:

      - filename: The full path you wish to save your screenshot to. This should end with a .png extension.

    Usage:

          driver.save_screenshot('/Screenshots/foo.png')

  set_network_conditions(**network_conditions) → None

    Sets Chromium network emulation settings.

    Args:

      - network_conditions: A dict with conditions specification.

    Usage:

          driver.set_network_conditions(
              offline=False,
              latency=5,  # additional latency (ms)
              download_throughput=500 * 1024,  # maximal throughput
              upload_throughput=500 * 1024)  # maximal throughput

      Note: ‘throughput’ can be used to set both (for download and upload).

  set_page_load_timeout(time_to_wait: float) → None

    Set the amount of time to wait for a page load to complete before throwing an error.

    Args:

      - time_to_wait: The amount of time to wait

    Usage:

          driver.set_page_load_timeout(30)

  set_permissions(name: str, value: str) → None

    Sets Applicable Permission.

    Args:

      - name: The item to set the permission on.

      - value: The value to set on the item

    Usage:

          driver.set_permissions('clipboard-read', 'denied')

  set_script_timeout(time_to_wait: float) → None

    Set the amount of time that the script should wait during an execute_async_script call before throwing an error.

    Args:

      - time_to_wait: The amount of time to wait (in seconds)

    Usage:

          driver.set_script_timeout(30)

  set_sink_to_use(sink_name: str) → dict

    Sets a specific sink, using its name, as a Cast session receiver target.

    Args:

      - sink_name: Name of the sink to use as the target.

  set_user_verified(verified: bool) → None

    Sets whether the authenticator will simulate success or fail on user verification.

    verified: True if the authenticator will pass user verification, False otherwise.

  set_window_position(x, y, windowHandle: str = 'current') → dict

    Sets the x,y position of the current window. (window.moveTo)

    Args:

      - x: the x-coordinate in pixels to set the window position

      - y: the y-coordinate in pixels to set the window position

    Usage:

          driver.set_window_position(0,0)

  set_window_rect(x=None, y=None, width=None, height=None) → dict

    Sets the x, y coordinates of the window as well as height and width of the current window. This method is only supported for W3C compatible browsers; other browsers should use set_window_position and set_window_size.

    Usage:

          driver.set_window_rect(x=10, y=10)
          driver.set_window_rect(width=100, height=200)
          driver.set_window_rect(x=10, y=10, width=100, height=200)

  set_window_size(width, height, windowHandle: str = 'current') → None

    Sets the width and height of the current window. (window.resizeTo)

    Args:

      - width: the width in pixels to set the window to

      - height: the height in pixels to set the window to

    Usage:

          driver.set_window_size(800,600)

  start_client()

    Called before starting a new session.

    This method may be overridden to define custom startup behavior.

  start_desktop_mirroring(sink_name: str) → dict

    Starts a desktop mirroring session on a specific receiver target.

    Args:

      - sink_name: Name of the sink to use as the target.

  start_session(capabilities: dict) → None

    Creates a new session with the desired capabilities.

    Args:

      - capabilities - a capabilities dict to start the session with.

  start_tab_mirroring(sink_name: str) → dict

    Starts a tab mirroring session on a specific receiver target.

    Args:

      - sink_name: Name of the sink to use as the target.

  stop_casting(sink_name: str) → dict

    Stops the existing Cast session on a specific receiver target.

    Args:

      - sink_name: Name of the sink to stop the Cast session.

  stop_client()

    Called after executing a quit command.

    This method may be overridden to define custom shutdown behavior.

  property switch_to: SwitchTo
    Returns:

      - SwitchTo: an object containing all options to switch focus into

    Usage:

          element = driver.switch_to.active_element
          alert = driver.switch_to.alert
          driver.switch_to.default_content()
          driver.switch_to.frame('frame_name')
          driver.switch_to.frame(1)
          driver.switch_to.frame(driver.find_elements(By.TAG_NAME, "iframe")[0])
          driver.switch_to.parent_frame()
          driver.switch_to.window('main')

  property timeouts: Timeouts

    Get all the timeouts that have been set on the current session.

    Usage:

          driver.timeouts

    Return type:

      Timeout

  property title: str

    Returns the title of the current page.

    Usage:

          title = driver.title

  unpin(script_key: ScriptKey) → None

    Remove a pinned script from storage.

  property virtual_authenticator_id: str

    Returns the id of the virtual authenticator.

  property window_handles: List[str]

    Returns the handles of all windows within the current session.

    Usage:

          driver.window_handles